## budgie-desktop-services 0.0.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

cmake_minimum_required(VERSION 3.20)

project(budgie-desktop-services VERSION 0.0.1)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_WARNINGS_IGNORE "deprecated-literal-operators")

set(KDE_COMPILERSETTINGS_LEVEL 6.0)

set(PROJECT_DEP_VERSION "6.1.80")
set(QT_MIN_VERSION "6.7")
set(KF6_MIN_VERSION "6.6.0")

find_package(ECM ${KF6_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEClangFormat)
include(KDEGitCommitHooks)
include(FeatureSummary)
include(ECMSetupVersion)
include(KDEInstallDirs)
include(KDECMakeSettings)
# include(KDECompilerSettings NO_POLICY_SCOPE)
include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMConfiguredInstall)

find_package(Qt6 ${QT_MIN_VERSION} NO_MODULE COMPONENTS Core DBus WaylandClient)

set_package_properties(
  Qt6 PROPERTIES
  TYPE REQUIRED
  PURPOSE "Basic application components")

find_package(Wayland REQUIRED)
find_package(QtWaylandScanner REQUIRED)
find_package(KWayland REQUIRED)
find_package(toml11 REQUIRED)

option(INSTALL_DESKTOP_FILE "Install desktop file" OFF)
option(INSTALL_SERVICE_FILES "Install service files for autostarting" OFF)
option(INSTALL_LABWC "Install autostart files for labwc" ON)

add_subdirectory(src)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES
                         FATAL_ON_MISSING_REQUIRED_PACKAGES)

#file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.hpp)
#kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

#kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

add_library(WaylandProtocols_xml OBJECT)
set_property(TARGET WaylandProtocols_xml PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(WaylandProtocols_xml PUBLIC Qt::Core Wayland::Client Plasma::KWaylandClient)
set_target_properties(WaylandProtocols_xml PROPERTIES LINKER_LANGUAGE C)

ecm_add_qtwayland_client_protocol(
  WaylandProtocols_xml PRIVATE_CODE PROTOCOL
  protocols/wlr-output-management-unstable-v1.xml BASENAME
  wlr-output-management-unstable-v1)

add_library(
  budgie-desktop-services STATIC
  config/display.cpp
  config/display.hpp
  config/format.hpp
  config/utils.cpp
  config/utils.hpp
  dbus/generated/BatchSystemAdaptorGen.cpp
  dbus/generated/BatchSystemAdaptorGen.h
  dbus/generated/DisplayAdaptorGen.cpp
  dbus/generated/DisplayAdaptorGen.h
  dbus/generated/OutputAdaptorGen.cpp
  dbus/generated/OutputAdaptorGen.h
  dbus/generated/OutputModeAdaptorGen.cpp
  dbus/generated/OutputModeAdaptorGen.h
  dbus/DisplaySchemaTypes.hpp
  dbus/BatchSystemService.cpp
  dbus/BatchSystemService.hpp
  dbus/DisplayObjectManager.cpp
  dbus/DisplayObjectManager.hpp
  dbus/DisplayService.cpp
  dbus/DisplayService.hpp
  dbus/OutputModeService.cpp
  dbus/OutputModeService.hpp
  dbus/OutputService.cpp
  dbus/OutputService.hpp
  displays/batch-system/CalculationResult.cpp
  displays/batch-system/CalculationResult.hpp
  displays/batch-system/ConfigurationAction.cpp
  displays/batch-system/ConfigurationAction.hpp
  displays/batch-system/ConfigurationBatchSystem.cpp
  displays/batch-system/ConfigurationBatchSystem.hpp
  displays/batch-system/enums.hpp
  displays/batch-system/OutputTargetState.cpp
  displays/batch-system/OutputTargetState.hpp
  displays/configuration.cpp
  displays/configuration.hpp
  displays/output-manager/head/enums.hpp
  displays/output-manager/head/WaylandOutputHead.cpp
  displays/output-manager/head/WaylandOutputHead.hpp
  displays/output-manager/head/WaylandOutputMetaHead.cpp
  displays/output-manager/head/WaylandOutputMetaHead.hpp
  displays/output-manager/mode/enums.hpp
  displays/output-manager/mode/WaylandOutputMetaMode.cpp
  displays/output-manager/mode/WaylandOutputMetaMode.hpp
  displays/output-manager/mode/WaylandOutputMode.cpp
  displays/output-manager/mode/WaylandOutputMode.hpp
  displays/output-manager/WaylandOutputManager.cpp
  displays/output-manager/WaylandOutputManager.hpp
  sys/SysInfo.cpp
  sys/SysInfo.hpp
)

add_executable(budgie-desktop-services-app main.cpp)
target_include_directories(
  budgie-desktop-services-app PRIVATE ${CMAKE_BINARY_DIR}
                               ${CMAKE_CURRENT_SOURCE_DIR}/includes)
target_link_libraries(budgie-desktop-services-app PRIVATE budgie-desktop-services)

target_include_directories(
  budgie-desktop-services
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/includes
          ${CMAKE_CURRENT_SOURCE_DIR}/config ${CMAKE_CURRENT_SOURCE_DIR}/dbus
          ${CMAKE_CURRENT_SOURCE_DIR}/displays ${CMAKE_CURRENT_SOURCE_DIR}/sys)

target_link_libraries(
  budgie-desktop-services PUBLIC Qt::Core Qt::DBus Qt::WaylandClient toml11::toml11 Wayland::Client
                          WaylandProtocols_xml)

set_target_properties(
  budgie-desktop-services-app PROPERTIES OUTPUT_NAME
                                  "org.buddiesofbudgie.Services")

install(TARGETS budgie-desktop-services-app ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES dbus/org.buddiesofbudgie.BudgieDaemon.conf
        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system.d)


if(INSTALL_DESKTOP_FILE)
  ecm_install_configured_files(
    INPUT data/org.buddiesofbudgie.Services.desktop.in DESTINATION
    ${KDE_INSTALL_AUTOSTARTDIR}
  )
endif()

if(INSTALL_LABWC)
  install(FILES data/labwc/autostart DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})
endif()

if(INSTALL_SERVICE_FILES)
  ecm_install_configured_files(
    INPUT data/org.buddiesofbudgie.Services.service.in DESTINATION
    ${KDE_INSTALL_SYSTEMDUSERUNITDIR})
endif()

=== debian/changelog ===
budgie-desktop-services (0.0.1-1) experimental; urgency=medium

  * Initial Release (Closes: #1120910)

 -- David Mohammed <fossfreedom@ubuntu.com>  Mon, 10 Nov 2025 18:55:34 +0000

=== debian/control ===
Source: budgie-desktop-services
Section: misc
Priority: optional
Maintainer: David Mohammed <fossfreedom@ubuntu.com>
Homepage: https://forge.moderndesktop.dev/BuddiesOfBudgie/budgie-desktop-services
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 qt6-wayland-dev,
 qt6-base-dev,
 kwayland-dev,
 libtoml11-dev
Standards-Version: 4.7.2
Vcs-Browser: https://github.com/ubuntubudgie/budgie-desktop-services/tree/debian
Vcs-Git: https://github.com/ubuntubudgie/budgie-desktop-services.git -b debian

Package: budgie-desktop-services
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Core package for all Budgie Desktop related services
 Budgie Desktop Services is the central hub and orchestrator for
 Budgie Desktop. It primarily provides Wayland-native display configuration
 for the Budgie 10.10 series.
 .
 Highlights
 .
 Wayland-native: Uses wlr-output-management-unstable-v1 to discover and
 configure outputs.
 Display Configuration Batch System: Build atomic display configuration
 changes and apply them safely in one go.
 Profiles via TOML: Persist and auto-apply display groups matched to
 current hardware.

## budgie-desktop-services 0.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.20)
 
-project(budgie-desktop-services VERSION 0.0.1)
+project(budgie-desktop-services VERSION 0.0.2)
 
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

add_library(WaylandProtocols_xml OBJECT)
set_property(TARGET WaylandProtocols_xml PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(WaylandProtocols_xml PUBLIC Qt::Core Wayland::Client Plasma::KWaylandClient)
set_target_properties(WaylandProtocols_xml PROPERTIES LINKER_LANGUAGE C)

ecm_add_qtwayland_client_protocol(
  WaylandProtocols_xml PRIVATE_CODE PROTOCOL
  protocols/wlr-output-management-unstable-v1.xml BASENAME
  wlr-output-management-unstable-v1)

set(budgie-desktop-services_SRCS
  # Config
  config/display.cpp
  config/display.hpp
  config/format.hpp
  config/utils.cpp
  config/utils.hpp
  # DBus Services
  dbus/DisplaySchemaTypes.hpp
  dbus/ConfigService.cpp
  dbus/ConfigService.hpp
  dbus/OutputsService.cpp
  dbus/OutputsService.hpp
  dbus/OutputModeService.cpp
  dbus/OutputModeService.hpp
  dbus/OutputService.cpp
  dbus/OutputService.hpp
  # Batch System
  outputs/config/enums/actiontype.hpp
  outputs/config/enums/anchors.hpp
  outputs/config/action.cpp
  outputs/config/action.hpp
  outputs/config/model.cpp
  outputs/config/model.hpp
  outputs/config/result.cpp
  outputs/config/result.hpp
  outputs/config/targetstate.cpp
  outputs/config/targetstate.hpp
  # Output (wlroots-specific)
  outputs/wlr/configuration.cpp
  outputs/wlr/configuration.hpp
  outputs/wlr/configurationhead.cpp
  outputs/wlr/configurationhead.hpp
  outputs/wlr/enums.hpp
  outputs/wlr/head.cpp
  outputs/wlr/head.hpp
  outputs/wlr/metahead.cpp
  outputs/wlr/metahead.hpp
  outputs/wlr/metamode.cpp
  outputs/wlr/metamode.hpp
  outputs/wlr/mode.cpp
  outputs/wlr/mode.hpp
  outputs/wlr/outputmanager.cpp
  outputs/wlr/outputmanager.hpp
  # Output State
  outputs/state.cpp
  outputs/state.hpp
  # System
  sys/SysInfo.cpp
  sys/SysInfo.hpp
)

qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Config.xml dbus/ConfigService.hpp bd::ConfigService)
qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Outputs.xml dbus/OutputsService.hpp bd::OutputsService)
qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Output.xml dbus/OutputService.hpp bd::OutputService)
qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.OutputMode.xml dbus/OutputModeService.hpp bd::OutputModeService)

add_library(
  budgie-desktop-services STATIC
  ${budgie-desktop-services_SRCS}
)

add_executable(budgie-desktop-services-app main.cpp)
target_include_directories(
  budgie-desktop-services-app PRIVATE ${CMAKE_BINARY_DIR}
                               ${CMAKE_CURRENT_SOURCE_DIR}/includes
                               ${CMAKE_CURRENT_BINARY_DIR}/dbus
                               ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(budgie-desktop-services-app PRIVATE budgie-desktop-services)

target_include_directories(
  budgie-desktop-services
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/includes
          ${CMAKE_CURRENT_SOURCE_DIR}/config ${CMAKE_CURRENT_SOURCE_DIR}/dbus
          ${CMAKE_CURRENT_SOURCE_DIR}/displays ${CMAKE_CURRENT_SOURCE_DIR}/sys)

target_link_libraries(
  budgie-desktop-services PUBLIC Qt::Core Qt::DBus Qt::WaylandClient toml11::toml11 Wayland::Client
                          WaylandProtocols_xml)

set_target_properties(
  budgie-desktop-services-app PROPERTIES OUTPUT_NAME
                                  "org.buddiesofbudgie.Services")

install(TARGETS budgie-desktop-services-app ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES dbus/org.buddiesofbudgie.Services.conf
        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system.d)


if(INSTALL_DESKTOP_FILE)
  ecm_install_configured_files(
    INPUT data/org.buddiesofbudgie.Services.desktop.in DESTINATION
    ${KDE_INSTALL_AUTOSTARTDIR}
  )
endif()

if(INSTALL_LABWC)
  install(FILES data/labwc/autostart DESTINATION ${KDE_INSTALL_SYSCONFDIR}/labwc)
endif()

if(INSTALL_SERVICE_FILES)
  ecm_install_configured_files(
    INPUT data/org.buddiesofbudgie.Services.service.in DESTINATION
    ${KDE_INSTALL_SYSTEMDUSERUNITDIR})
endif()

=== debian/changelog ===
budgie-desktop-services (0.0.2-1) experimental; urgency=medium

  * Initial Release (Closes: #1120910)

 -- David Mohammed <fossfreedom@ubuntu.com>  Sat, 27 Dec 2025 21:58:29 +0000

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  kwayland-dev,
  libtoml11-dev
 Standards-Version: 4.7.2
-Vcs-Browser: https://github.com/ubuntubudgie/budgie-desktop-services/tree/debian
-Vcs-Git: https://github.com/ubuntubudgie/budgie-desktop-services.git -b debian
+Vcs-Browser: https://github.com/ubuntubudgie/budgie-desktop-services
+Vcs-Git: https://github.com/ubuntubudgie/budgie-desktop-services.git
 
 Package: budgie-desktop-services
 Architecture: any

## budgie-desktop-services 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.20)
 
-project(budgie-desktop-services VERSION 0.0.2)
+project(budgie-desktop-services VERSION 1.0.0)
 
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

=== debian/changelog ===
budgie-desktop-services (1.0.0-1) experimental; urgency=medium

  * Initial Release (Closes: #1120910)

 -- David Mohammed <fossfreedom@ubuntu.com>  Mon, 12 Jan 2026 19:26:17 +0000

## budgie-desktop-services 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.20)
 
-project(budgie-desktop-services VERSION 1.0.0)
+project(budgie-desktop-services VERSION 1.0.2)
 
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
@@ -45,7 +45,7 @@
 
 option(INSTALL_DESKTOP_FILE "Install desktop file" OFF)
 option(INSTALL_SERVICE_FILES "Install service files for autostarting" OFF)
-option(INSTALL_LABWC "Install autostart files for labwc" ON)
+option(INSTALL_LABWC "Install autostart files for labwc" OFF)
 
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -14,21 +14,19 @@
 
 set(budgie-desktop-services_SRCS
   # Config
-  config/display.cpp
-  config/display.hpp
-  config/format.hpp
+  config/outputs/global_preferences.cpp
+  config/outputs/global_preferences.hpp
+  config/outputs/group.cpp
+  config/outputs/group.hpp
+  config/outputs/output.cpp
+  config/outputs/output.hpp
+  config/outputs/state.cpp
+  config/outputs/state.hpp
   config/utils.cpp
   config/utils.hpp
   # DBus Services
-  dbus/DisplaySchemaTypes.hpp
   dbus/ConfigService.cpp
   dbus/ConfigService.hpp
-  dbus/OutputsService.cpp
-  dbus/OutputsService.hpp
-  dbus/OutputModeService.cpp
-  dbus/OutputModeService.hpp
-  dbus/OutputService.cpp
-  dbus/OutputService.hpp
   # Batch System
   outputs/config/enums/actiontype.hpp
   outputs/config/enums/anchors.hpp
@@ -40,6 +38,9 @@
   outputs/config/result.hpp
   outputs/config/targetstate.cpp
   outputs/config/targetstate.hpp
+  # Output
+  outputs/types.cpp
+  outputs/types.hpp
   # Output (wlroots-specific)
   outputs/wlr/configuration.cpp
   outputs/wlr/configuration.hpp
@@ -65,9 +66,9 @@
 )
 
 qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Config.xml dbus/ConfigService.hpp bd::ConfigService)
-qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Outputs.xml dbus/OutputsService.hpp bd::OutputsService)
-qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Output.xml dbus/OutputService.hpp bd::OutputService)
-qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.OutputMode.xml dbus/OutputModeService.hpp bd::OutputModeService)
+qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Outputs.xml outputs/state.hpp bd::Outputs::State)
+qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.Output.xml outputs/wlr/metahead.hpp bd::Outputs::Wlr::MetaHead)
+qt_add_dbus_adaptor(budgie-desktop-services_SRCS dbus/schemas/DisplaySchema.OutputMode.xml outputs/wlr/metamode.hpp bd::Outputs::Wlr::MetaMode)
 
 add_library(
   budgie-desktop-services STATIC

=== debian/changelog ===
budgie-desktop-services (1.0.2-1) experimental; urgency=medium

  * Initial Release (Closes: #1120910)

 -- David Mohammed <fossfreedom@ubuntu.com>  Sun, 18 Jan 2026 19:05:19 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  qt6-base-dev,
  kwayland-dev,
  libtoml11-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://github.com/ubuntubudgie/budgie-desktop-services
 Vcs-Git: https://github.com/ubuntubudgie/budgie-desktop-services.git

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DINSTALL_LABWC=OFF

=== debian/watch ===
Version: 5

Source: https://forge.moderndesktop.dev/BuddiesOfBudgie/budgie-desktop-services/tags
Matching-Pattern: .*/@ANY_VERSION@@ARCHIVE_EXT@
